Przejdź do głównej treści
POST
/
v1beta
/
models
/
{model}
:
{operator}
from google import genai

client = genai.Client(
    api_key="<COMETAPI_KEY>",
    http_options={"api_version": "v1beta", "base_url": "https://api.cometapi.com"},
)

response = client.models.generate_content(
    model="gemini-2.5-flash",
    contents="Explain how AI works in a few words",
)

print(response.text)
{
  "candidates": [
    {
      "content": {
        "role": "<string>",
        "parts": [
          {
            "text": "<string>",
            "functionCall": {
              "name": "<string>",
              "args": {}
            },
            "inlineData": {
              "mimeType": "<string>",
              "data": "<string>"
            },
            "thought": true
          }
        ]
      },
      "finishReason": "STOP",
      "safetyRatings": [
        {
          "category": "<string>",
          "probability": "<string>",
          "blocked": true
        }
      ],
      "citationMetadata": {
        "citationSources": [
          {
            "startIndex": 123,
            "endIndex": 123,
            "uri": "<string>",
            "license": "<string>"
          }
        ]
      },
      "tokenCount": 123,
      "avgLogprobs": 123,
      "groundingMetadata": {
        "groundingChunks": [
          {
            "web": {
              "uri": "<string>",
              "title": "<string>"
            }
          }
        ],
        "groundingSupports": [
          {
            "groundingChunkIndices": [
              123
            ],
            "confidenceScores": [
              123
            ],
            "segment": {
              "startIndex": 123,
              "endIndex": 123,
              "text": "<string>"
            }
          }
        ],
        "webSearchQueries": [
          "<string>"
        ]
      },
      "index": 123
    }
  ],
  "promptFeedback": {
    "blockReason": "SAFETY",
    "safetyRatings": [
      {
        "category": "<string>",
        "probability": "<string>",
        "blocked": true
      }
    ]
  },
  "usageMetadata": {
    "promptTokenCount": 123,
    "candidatesTokenCount": 123,
    "totalTokenCount": 123,
    "trafficType": "<string>",
    "thoughtsTokenCount": 123,
    "promptTokensDetails": [
      {
        "modality": "<string>",
        "tokenCount": 123
      }
    ],
    "candidatesTokensDetails": [
      {
        "modality": "<string>",
        "tokenCount": 123
      }
    ]
  },
  "modelVersion": "<string>",
  "createTime": "<string>",
  "responseId": "<string>"
}

Przegląd

CometAPI obsługuje natywny format API Gemini, zapewniając pełny dostęp do funkcji specyficznych dla Gemini, takich jak kontrola myślenia, ugruntowanie w Google Search, natywne modalności generowania obrazów i inne. Użyj tego endpointu, gdy potrzebujesz możliwości niedostępnych przez endpoint czatu zgodny z OpenAI.

Szybki start

Zastąp bazowy URL i klucz API w dowolnym SDK Gemini lub kliencie HTTP:
UstawienieDomyślne GoogleCometAPI
Bazowy URLgenerativelanguage.googleapis.comapi.cometapi.com
Klucz API$GEMINI_API_KEY$COMETAPI_KEY
Zarówno nagłówek x-goog-api-key, jak i Authorization: Bearer są obsługiwane do uwierzytelniania.

Myślenie (Reasoning)

Modele Gemini mogą wykonywać wewnętrzne rozumowanie przed wygenerowaniem odpowiedzi. Metoda kontroli zależy od generacji modelu.
Modele Gemini 3 używają thinkingLevel do kontrolowania głębokości rozumowania. Dostępne poziomy: MINIMAL, LOW, MEDIUM, HIGH.
curl "https://api.cometapi.com/v1beta/models/gemini-3.1-pro-preview:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "Explain quantum physics simply."}]}],
    "generationConfig": {
      "thinkingConfig": {"thinkingLevel": "LOW"}
    }
  }'
Użycie thinkingLevel z modelami Gemini 2.5 (lub thinkingBudget z modelami Gemini 3) może powodować błędy. Używaj właściwego parametru dla wersji swojego modelu.

Streaming

Użyj streamGenerateContent?alt=sse jako operatora, aby odbierać Server-Sent Events podczas generowania treści przez model. Każde zdarzenie SSE zawiera linię data: z obiektem JSON GenerateContentResponse.
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:streamGenerateContent?alt=sse" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  --no-buffer \
  -d '{
    "contents": [{"parts": [{"text": "Write a short poem about the stars"}]}]
  }'

Instrukcje systemowe

Steruj zachowaniem modelu w całej rozmowie za pomocą systemInstruction:
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "What is 2+2?"}]}],
    "systemInstruction": {
      "parts": [{"text": "You are a math tutor. Always show your work."}]
    }
  }'

Tryb JSON

Wymuś ustrukturyzowane wyjście JSON za pomocą responseMimeType. Opcjonalnie podaj responseSchema dla ścisłej walidacji schematu:
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "List 3 planets with their distances from the sun"}]}],
    "generationConfig": {
      "responseMimeType": "application/json"
    }
  }'

Włącz wyszukiwanie w sieci w czasie rzeczywistym, dodając narzędzie googleSearch:
curl "https://api.cometapi.com/v1beta/models/gemini-2.5-flash:generateContent" \
  -H "Content-Type: application/json" \
  -H "x-goog-api-key: $COMETAPI_KEY" \
  -d '{
    "contents": [{"parts": [{"text": "Who won the euro 2024?"}]}],
    "tools": [{"google_search": {}}]
  }'
Odpowiedź zawiera groundingMetadata z adresami URL źródeł i ocenami pewności.

Przykład odpowiedzi

Typowa odpowiedź z endpointu Gemini w CometAPI:
{
  "candidates": [
    {
      "content": {
        "role": "model",
        "parts": [{"text": "Hello"}]
      },
      "finishReason": "STOP",
      "avgLogprobs": -0.0023
    }
  ],
  "usageMetadata": {
    "promptTokenCount": 5,
    "candidatesTokenCount": 1,
    "totalTokenCount": 30,
    "trafficType": "ON_DEMAND",
    "thoughtsTokenCount": 24,
    "promptTokensDetails": [{"modality": "TEXT", "tokenCount": 5}],
    "candidatesTokensDetails": [{"modality": "TEXT", "tokenCount": 1}]
  },
  "modelVersion": "gemini-2.5-flash",
  "createTime": "2026-03-25T04:21:43.756483Z",
  "responseId": "CeynaY3LDtvG4_UP0qaCuQY"
}
Pole thoughtsTokenCount w usageMetadata pokazuje, ile tokenów model zużył na wewnętrzne rozumowanie, nawet jeśli wynik myślenia nie jest uwzględniony w odpowiedzi.

Kluczowe różnice względem endpointu zgodnego z OpenAI

FunkcjaGemini Native (/v1beta/models/...)OpenAI-Compatible (/v1/chat/completions)
Kontrola myśleniathinkingConfig z thinkingLevel / thinkingBudgetNiedostępne
Grounding z Google Searchtools: [\{"google_search": \{\}\}]Niedostępne
Grounding z Google Mapstools: [\{"googleMaps": \{\}\}]Niedostępne
Modalność generowania obrazówresponseModalities: ["IMAGE"]Niedostępne
Nagłówek autoryzacjix-goog-api-key lub BearerTylko Bearer
Format odpowiedziNatywny Gemini (candidates, parts)Format OpenAI (choices, message)

Autoryzacje

x-goog-api-key
string
header
wymagane

Your CometAPI key passed via the x-goog-api-key header. Bearer token authentication (Authorization: Bearer <key>) is also supported.

Parametry ścieżki

model
string
wymagane

The Gemini model ID to use. See the Models page for current Gemini model IDs.

Przykład:

"gemini-2.5-flash"

operator
enum<string>
wymagane

The operation to perform. Use generateContent for synchronous responses, or streamGenerateContent?alt=sse for Server-Sent Events streaming.

Dostępne opcje:
generateContent,
streamGenerateContent?alt=sse
Przykład:

"generateContent"

Treść

application/json
contents
object[]
wymagane

The conversation history and current input. For single-turn queries, provide a single item. For multi-turn conversations, include all previous turns.

systemInstruction
object

System instructions that guide the model's behavior across the entire conversation. Text only.

tools
object[]

Tools the model may use to generate responses. Supports function declarations, Google Search, Google Maps, and code execution.

toolConfig
object

Configuration for tool usage, such as function calling mode.

safetySettings
object[]

Safety filter settings. Override default thresholds for specific harm categories.

generationConfig
object

Configuration for model generation behavior including temperature, output length, and response format.

cachedContent
string

The name of cached content to use as context. Format: cachedContents/{id}. See the Gemini context caching documentation for details.

Odpowiedź

200 - application/json

Successful response. For streaming requests, the response is a stream of SSE events, each containing a GenerateContentResponse JSON object prefixed with data:.

candidates
object[]

The generated response candidates.

promptFeedback
object

Feedback on the prompt, including safety blocking information.

usageMetadata
object

Token usage statistics for the request.

modelVersion
string

The model version that generated this response.

createTime
string

The timestamp when this response was created (ISO 8601 format).

responseId
string

Unique identifier for this response.